<template>
  <q-page class="q-pa-md items-start q-gutter-md">
    <template v-if="payload.device.appVersionName !== ''">
      <h2>Actions</h2>
      <div class="row items-start q-gutter-x-md"></div>
      <h2>App Info</h2>
      <div class="row items-start q-gutter-x-md">
        <DashCard title="System state" :caption="payload.system.state" />
        <DashCard title="Player state" :caption="payload.player.state" />
        <DashCard title="Network state" :caption="payload.network.state" />
        <DashCard title="App Key" :caption="payload.app.key" />
        <DashCard
          v-if="payload.user.install.id !== ''"
          title="Install ID"
          :caption="payload.user.install.id"
          :since="payload.user.install.timestamp"
        />
        <DashCard v-else title="Pointzi integration not completed" />
        <DashCard
          v-if="payload.app.token !== ''"
          title="App Token"
          :caption="payload.app.token"
        />
        <DashCard
          v-if="payload.user.id !== ''"
          title="User ID"
          :caption="payload.user.id"
        />
        <DashCard title="Platform" :caption="payload.device.platformName" />
      </div>
      <h2>Session</h2>
      <div class="row items-start q-gutter-x-md">
        <DashCard
          title="Session #"
          :caption="payload.user.session.id.toString()"
        />
        <DashCard
          title="Current Activity"
          :caption="payload.user.current_activity.friendly_name"
        />
      </div>
      <h2>Guides</h2>
      <template v-if="!isEmpty(payload.player.feeds.preview)">
        <h6 class="text-primary">Preview Mode</h6>
        <div class="row items-start q-gutter-md">
          <template v-for="(feed, index) in payload.player.feeds.preview">
            <GuideCard :id="index.split('_')[2]" :feed="feed" :key="index" />
          </template>
        </div>
      </template>

      <template v-if="!isEmpty(payload.player.feeds.real)">
        <h6 class="text-primary" style="margin-bottom: 0">
          Real Mode
        </h6>
        <div class="row items-start q-gutter-md">
          <template v-for="(feed, index) in payload.player.feeds.real">
            <GuideCard
              :id="
                index
                  .replace(payload.app.key, '')
                  .replace(payload.user.install.id, '')
                  .replaceAll('_', '')
              "
              :feed="feed"
              :key="index"
            />
          </template>
        </div>
      </template>
      <h2>Network</h2>
      <div class="row items-start q-gutter-md">
        <LoglineTable title="Queued Loglines" :items="bundledLoglines" />
        <LoglineTable title="Recently Sent Loglines" :items="loglines" />
      </div>
      <h2>Debug Logs (Only Pointzi)</h2>
      <div class="row items-start q-gutter-md">
        <q-btn color="red" icon="delete" @click="clearDebug" label="CLEAR" />
        <q-btn
          :color="this.$store.state.debugPaused ? 'green' : 'primary'"
          :icon="this.$store.state.debugPaused ? 'play_arrow' : 'pause'"
          @click="toggleDebug"
          :label="this.$store.state.debugPaused ? 'resume' : 'pause'"
        />
        <q-toggle v-model="debug.d" label="Debug" />
        <q-toggle v-model="debug.i" label="Info" />
        <q-toggle v-model="debug.w" label="Warning" />
        <q-toggle v-model="debug.e" label="Error" />
      </div>
      <q-list dense bordered class="rounded-borders">
        <q-item v-for="(item, index) in debugLogs" :key="index">
          <q-item-section>
            {{ item.level }} : {{ item.message }}
          </q-item-section>
        </q-item>
      </q-list>
    </template>
    <h1 v-else class="col-12 text-center">No app connected!</h1>
  </q-page>
</template>

<script>
import DashCard from 'components/DashCard'
import GuideCard from 'components/GuideCard'
import LoglineTable from 'components/LoglineTable'
import { mapMutations } from 'vuex'

export default {
  name: 'PageIndex',
  components: {
    LoglineTable,
    DashCard,
    GuideCard
  },
  data () {
    return {
      debug: {
        d: true,
        i: true,
        w: true,
        e: true,
        filter: { min: Date.now() - 10, max: Date.now() }
      }
    }
  },
  computed: {
    payload () {
      return this.$store.state.payload
    },
    bundledLoglines () {
      return this.$store.state.payload.network.loglines.bundle
    },
    loglines () {
      return this.$store.state.loglines
    },
    debugLogs () {
      return this.$store.state.debugLogs
        .slice()
        .reverse()
        .filter(log => {
          if (this.debug.d && log.level === 'DEBUG') return true
          if (this.debug.i && log.level === 'INFO') return true
          if (this.debug.w && log.level === 'WARN') return true
          if (this.debug.e && log.level === 'ERROR') return true
        })
    },
    debugRange () {
      if (this.debugLogs.length > 0) {
        var min = this.debugLogs[this.debugLogs.length - 1].timestamp
        var max = this.debugLogs[0].timestamp

        if (min === undefined) min = Date.now() - 10
        if (max === undefined) max = Date.now()

        return { min, max }
      } else {
        return { min: Date.now() - 10, max: Date.now() }
      }
    }
  },
  filteredDebugLogs () {
    return this.debugLogs.filter(log => {
      return log.timestamp > this.debug.filter.min && log.timestamp < this.debug.filter.max
    })
  },
  methods: {
    ...mapMutations({
      toggleDebug: 'TOGGLE_DEBUG_PAUSE',
      clearDebug: 'CLEAR_DEBUG'
    }),
    isEmpty (obj) {
      for (const key in obj) {
        // eslint-disable-next-line no-prototype-builtins
        if (obj.hasOwnProperty(key)) {
          return false
        }
      }
      return true
    }
  }
}
</script>

<style lang="sass">
.q-page
  padding: 10px
</style>
